CON

'TODO
{{


        Add ability to update firmware in the field [via network]

        Add Art-Net address parsing [Bonus feature]

        Move SaveDefaults Method to the WebServer. This way, there will be no lockup during EEprom write process.
        Figure out why the first DHCP attempt always results in an error.

        Create Beeping/Blinking LED routine for when IP changes/Defaults Saved

        Currently, When input mode is switched to DMX and all cogs are in use, nothing happens.
                Send an error message when this happens, and switch BACK to previous Input Mode.

        Convert WSTimer to an actual Time value instead of an arbitrary number

        Check the functionallity of the Reset button.


'}}




CON

  _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000

  numPorts = 4'

  HTMLBufferSize = 2048

  'Pin assignments for W5100
  _scs  = 16
  _sclk = 17
  _mosi = 23
  _miso = 22
  _reset = 20

  EthRX = 3
  EthTX = 4
  EthLk = 5

  'Pin assignments for DMX
  DMXDataIn     = 2
  DMXDataOut    = 1
  DMXStatusLed  = 26
  DMXtxrxEn     = 0

  ' Port Data/Clock Pin Assignments 
  ' See DAT section

  'Status LED Pin Assignments
  StatLed1 = 9
  StatLed2 = 10
  StatLed3 = 11
  StatLed4 = 12

  'Reset Pin
  Reset = 8
   
  ' Main StateMachine Constants
  Initialize            = 1
  GetValidIP            = 2
  ObtainDHCP            = 3
  CheckForTCPConnection = 4
  DataForWebserver      = 5
  SendWebServerData     = 6
  ResetState            = 7

  
  IDLE                  = 100

  ' Upper EEPROM Address Constants
  '2 ports
  {EeMACaddress = $8080
  EeGatewayAddress = $8088
  EeSubnetMask = $808E
  EeIPAddress = $8094
  EeIPMode = $809A
  EeInputMode = $809D
  EePortUniverse = $80A0
  EePortStartAddr = $80A4
  EePortStyle = $80AA
  EePortPixelCount = $80AE
  '}
  '4 ports
  EeMACaddress = $8080
  EeGatewayAddress = $8088
  EeSubnetMask = $808E
  EeIPAddress = $8094
  EeIPMode = $809A
  EeInputMode = $809D
  EePortUniverse = $80A0
  EePortStartAddr = $80A6
  EePortStyle = $80B0
  EePortPixelCount = $80B6
                     
  UDPHeaderOffset       = 8
  
  'ArtPollReply Offsets
  ArtPollOpCode_offset   = 8
  ArtPollNetSwitchOffset = 18
  ArtPollSubSwitchOffset = 19
  
  'ArtDmxOuput Offsets
  ArtDMXNetOffset    = 15
  ArtDMXSubOffset    = 14
  ArtDMXLengthOffset = 16
  ArtDMXDataOffset   = 18  

  'ArtAddress Offsets
  AddrNetSwitchOffset    = 12
   
  'ArtNet OpCodes
  OpPoll              = $2000
  OpPollReply         = $2100
  OpAddress           = $6000
  OpOutput            = $5000

  'IPMode
  StaticIP  = 0
  DynamicIP = 1
  NetworkOff = 2
  NetworkOn  = 3
  
  'InputMode
  DMX_mode    = 0
  ArtNet_mode = 1
  sACN_mode   = 2
  'PortStyle
  Strip_style       = 0 'LPD8806 
  Strand_style      = 1 'WS2801
  

  webServerSocket = 0
  webServerListenPort = 80
  artnetSocket    = 1
  artnetPort      = $1936
  DHCPSocket      = 2

  'FDS port number
  DEBUG = 0

  DMXUniverseBufferLength = 512
  UDPPacketBufferLength   = 576

  LEDFrameDelay = 5
        
  ENABLE   = 1
  DISABLE  = 0

  SocketCloseDelay = 1000 'mS

    'PostedChanges
  Int_NetMode     = %00000000_00000001
  Int_selectInput = %00000000_00000010
  Int_IP          = %00000000_00000100
  Int_Subnet      = %00000000_00001000
  Int_Gateway     = %00000000_00010000
  Int_portU       = %00000000_00100000
  Int_portS       = %00000000_01000000
  Int_selectStyle = %00000000_10000000
  Int_PixelCount  = %00000001_00000000
  Int_Renew       = %00000010_00000000
  Int_defaults    = %00000100_00000000
  Int_Ready       = %01000000_00000000
  Int_Finished    = %10000000_00000000
  
  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  'CLK_FREQ = 80_000_000 
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  #0,  LEDResetState, R1, R2, R3, R4, R5, R6, R7, R8
  #10, LEDStatusNormal, N1, N2, N3
    
OBJ

  D2E   :       "DAT to EEPROM 10.2.12.spin"
  WEB   :       "WSE-SSD WebServer 11.20.12 No DHCP.spin"
  Eth   :       "W5100_SPI_Driver 11.14.12.spin"
  'DHCP  :       "DHCP 11.19.12.spin"
  I2C   :       "Basic_I2C_Driver.spin"
  DMX   :       "jm_dmxin.spin"
  NUM   :       "Simple_Numbers.spin"
  'Flash :       "LEDflash_Indicator.spin"

  led[numPorts]:  "jm_ws2801 - 11.6.12.spin" 
  
  FDS      : "fullDuplexSerial4port.spin"
  DIO      : "dataIO4port.spin"

  'STK   :       "Stack Length.spin"
  
VAR

  long  State
  long  validIP
  long  attemptDHCP
  long  dataLength
  long  socketTimer
  long  sockWaitTimer
  long  WSTimer
  long  DHCPtimer
  long  MachineTimer
  
  'long  stack1[13]

  long  _DMXBufferAddress
  long  _DMXBufferReady

  long  ledColorAddr[numPorts]

  long counter1, counter2
  long timer
  long NewConnection

  long WSInterrupt

  long Activity

  long NetworkUploadPending
  long sendArtPollReply

  long WSResetReady

  long LEDStatusState
  long LEDStatusTicks
  
PUB Main | returnVal        'This is the state machine that runs in the higher level object!

  'Flash.pins(StatLed3, StatLed4)
  
  State := Initialize
  
  returnVal := cnt
  LEDStatusState := LEDStatusNormal
  repeat while INA[Reset] == 0 
    if cnt-returnVal > clkfreq*3
      State := ResetState
      LEDStatusState := LEDResetState
      quit   
  
  'Start terminal debugger.
  waitcnt(cnt+clkfreq*2)
  FDS.INIT
  fds.AddPort(DEBUG, 31, 30, -1, -1, 0, 0, 57600)
  returnVal := fds.Start
  fds.tx(debug, 16) ' Clear Screen
  fds.str(DEBUG, String("FDS Terminal running on cog "))
  dio.dec(DEBUG, returnVal)
  fds.tx(DEBUG, ".")
  fds.tx(DEBUG, 13)  

  'Set Status LEDs to Output
  DIRA |= |< StatLed1
  DIRA |= |< StatLed2
  DIRA |= |< StatLed3
  DIRA |= |< StatLed4

  ''Optionally setermine Stack Length
  'STK.Init(@stack1, 100)
  
  MachineTimer := cnt
  timer := cnt      
  repeat
    stateMachine
    {
    choke := false
    repeat until ((cnt - MachineTimer) => MS_001)
      choke := true
      'fds.tx(DEBUG, "*")
    if choke
      MachineTimer += MS_001
    else
      MachineTimer := MS_001 + cnt
    '}
PUB stateMachine | ReturnVal, nextState
  
  
  'PrintIterations
  
  'repeat:
  CASE State    'For ALL Networking Features
    Initialize:

      Init
      'GOTO IDLE  .
      nextState := IDLE

    ResetState:
      bytefill(@GatewayAddress, 0, 14)
      bytefill(@PortUniverse, 0, 5*numports)
      byte[@IPAddress][0] := 192
      byte[@IPAddress][1] := 168
      byte[@IPAddress][2] := 1
      byte[@IPAddress][3] := 1
      byte[@SubnetMask][0] := 255
      byte[@SubnetMask][1] := 255
      byte[@SubnetMask][2] := 255
      byte[@SubnetMask][3] := 0      
      saveDefaults
      fds.str(DEBUG, String("Defaults Reset!", 13))
      nextState := Initialize  
      
    GetValidIP:
      nextState := ParseIPMode
      
    {ObtainDHCP:
      returnVal := tryDHCP
      nextState := IDLE
      if ReturnVal == DHCP#SUCCESS
        DHCPtimer := 0
        ValidIP := TRUE
        DHCP.GetIP(@IPAddress)
        DHCP.GetGatewayIP(@GatewayAddress)
        DHCP.GetSubnetMask(@SubnetMask)
        fds.str(DEBUG, String("DHCP Success.", 13))
        fds.Str(Debug, string("IP: "))
        printIP(@IPAddress)
        fds.tx(DEBUG, 13)
        if Eth.SocketTCPstatus(webServerSocket) == Eth#_SOCK_LISTEN
          UploadNetworkSettings
          NetworkUploadPending := False
        else        
          NetworkUploadPending := True
        HTMLConcat(String("Using Dynamic IP <a href='http://"))
        HTMLConcatIP(@IPAddress)
        HTMLConcat(String("/'>http://"))
        HTMLConcatIP(@IPAddress)
        HTMLConcat(String("/</a>.", 13, 10))
        WSinterrupt &= !Int_Finished
      else
        ValidIP := False
        fds.str(DEBUG, String("DHCP Error: "))
        dio.dec(DEBUG, ReturnVal)
        fds.tx(DEBUG, 13)
        NetworkUploadPending := False        
        if DHCPtimer++ == 3
          byte[@IPMode] := StaticIP
          DHCPtimer := 0
          fds.str(DEBUG, String("   DHCP Server not found.", 13))
          HTMLConcat(String("DHCP Server not found.", 13, 10))
          WSinterrupt &= !Int_Finished          
     '} 
   
    DataForWebserver:
      if !WEB.isBusy
        WSTimer := cnt  
        WEB.setCommand(WEB#ReceivedHTML)
        nextState := IDLE
      else
        nextState := DataForWebserver  
        if WSTimer++ > 20
          WSTimer := 0
          fds.str(DEBUG, String("   WebServer is too busy to receive data."))
          nextState := IDLE
        
    SendWebServerData:
      CASE Eth.SocketTCPstatus(webServerSocket)
        Eth#_SOCK_ESTAB     :
          Eth.txTCP(webServerSocket, @HTMLBuffer, WEB.getDataLength)
          WEB.isReadyToSend(WEB#RESET)
          nextState := IDLE
        OTHER:
          ' Error: client closed the connection
          fds.str(debug, string("   Client closed the connection before data could be sent.", 13))
          WEB.isReadyToSend(WEB#RESET)
          nextState := IDLE
      
    IDLE:
      Activity := 0

      if WSinterrupt & Int_Ready
        WSinterrupt &= !Int_Ready
        CheckInterrupts

      
      if WEB.isReadyToSend(WEB#QUERY)
        nextState := SendWebServerData
      elseIf ValidIP == FALSE
        nextState := GetValidIP
      else 
        nextState := MonitorSocket
      
    Other:
      nextState := IDLE
      
  ''Debugging methods:
  'PrintState(nextState)  
  'PrintWebSocketStatus

  state := nextState
  
  CheckForArtnet
  CheckForDMX
  statusLedControl

  ''Need to put here a State Machine Frame Timer that delays every 1mS

   
  'waitcnt(((clkfreq / 200 ) #> 381) + cnt)
  {if MachineTimer > cnt
    waitcnt(MachineTimer+= clkfreq/1000)
  else
    MachineTimer += ((clkfreq/1000) #> 381)
  '}

Pri ParseIPMode : nextState

  CASE byte[@IPMode]
    StaticIP:
      'Write current IP Address, Subnet Mask, Gateway Address to W5100
      'Eth.InitAddresses(true, @MACAddress, @GatewayAddress, @SubnetMask, @IPAddress)
      NetworkUploadPending := True
      ValidIP := TRUE
     
      fds.str(DEBUG, String("Using Static IP "))
      printIP(@IPAddress)
      fds.str(DEBUG, String(".", 13)) 

      HTMLConcat(String("Using static IP <a href='http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/'>http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/</a>.", 13, 10))
      'fds.str(DEBUG, String("RESETING INT", 13))
      WSinterrupt &= !Int_Finished 
      
      nextState := IDLE

    {DynamicIP:
      if attemptDHCP == TRUE
        nextState := ObtainDHCP
    '}    
    NetworkOff:
                                 ' u    v    w    x    y    z
     'MACaddress       byte      $00, $08, $DC, $09, $09, $86  'Hard Coded
            
      byte[@IPAddress][0]  := 2 'NetworkOff
      byte[@IPAddress][1]  := byte[@APROemHi] + byte[@APROemLo] + byte[@MACaddress][3]
      byte[@IPAddress][2]  := byte[@MACaddress][4]
      byte[@IPAddress][3]  := byte[@MACaddress][5]
     
      byte[@SubnetMask][0] := 255
      byte[@SubnetMask][1] := 0
      byte[@SubnetMask][2] := 0
      byte[@SubnetMask][3] := 0
     
      byte[@GateWayAddress][0] := 0
      byte[@GateWayAddress][1] := 0
      byte[@GateWayAddress][2] := 0
      byte[@GateWayAddress][3] := 0
      
      'Eth.InitAddresses(true, @MACAddress, @GatewayAddress, @SubnetMask, @IPAddress)
      NetworkUploadPending := True  
      ValidIP := TRUE
     
      fds.str(DEBUG, String("ArtNet 'NetworkOff' mode, IP: "))
      printIP(@IPAddress)
      fds.str(DEBUG, String(".", 13))

      HTMLConcat(String("Using static IP <a href='http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/'>http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/</a>.", 13, 10))
      WSinterrupt &= !Int_Finished
      
      nextState := IDLE
                     
    NetworkOn:
     
                                 ' u    v    w    x    y    z
     'MACaddress       byte      $00, $08, $DC, $09, $09, $86  'Hard Coded
            
      byte[@IPAddress][0]  := 10  'NetworkOn
      byte[@IPAddress][1]  := byte[@APROemHi] + byte[@APROemLo] + byte[@MACaddress][3]
      byte[@IPAddress][2]  := byte[@MACaddress][4]
      byte[@IPAddress][3]  := byte[@MACaddress][5]
     
      byte[@SubnetMask][0] := 255
      byte[@SubnetMask][1] := 0
      byte[@SubnetMask][2] := 0
      byte[@SubnetMask][3] := 0
     
      byte[@GateWayAddress][0] := 0
      byte[@GateWayAddress][1] := 0
      byte[@GateWayAddress][2] := 0
      byte[@GateWayAddress][3] := 0
      
      'Eth.InitAddresses(true, @MACAddress, @GatewayAddress, @SubnetMask, @IPAddress)
      NetworkUploadPending := True  
      ValidIP := TRUE
     
      fds.str(DEBUG, String("ArtNet 'NetworkOn' mode, IP: "))
      printIP(@IPAddress)
      fds.str(DEBUG, String(".", 13))

      HTMLConcat(String("Using static IP <a href='http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/'>http://"))
      HTMLConcatIP(@IPAddress)
      HTMLConcat(String("/</a>.", 13, 10))
      WSinterrupt &= !Int_Finished
      
      nextState := IDLE
      
              
    OTHER:
      fds.str(DEBUG, String("   Non-valid IPMode.", 13))
      nextState := IDLE
   
  return nextState
          
Pri CheckForArtnet | returnVal
''This method checks for data on the UDP socket and parses it.

  if(returnVal := Eth.rxUDP(artnetSocket, @UDPPacket))
    'data[0]..[3] is the source IP address, data[4],[5] is the source port, data[6],[7] is the payload size and data[8] starts the payload
    'Compare packet to ArtPoll
    if(strcomp(@UDPPacket[8], @ArtPoll)) 'Is this an Art-Net packet?
      CASE word[@UDPPacket][ArtPollOpCode_offset] 'Compare OpCodes
        OpPoll:
          sendArtPollReply := true
          Activity := 1
        OpPollReply:
          'Do Nothing
        OpOutput:
          if(byte[@InputMode] == ArtNet_mode)
            Activity := ParseArtDMX
            counter2++                           'This counter keeps track of # of ArtDMX packets processed per unit of time.
        OpAddress:
          if(byte[@InputMode] == ArtNet_mode)
            ParseArtAddress
        OTHER:
          fds.str(DEBUG, String("   Unkown Art-Net packet.", 13))
    else
      fds.str(DEBUG, String("   Received non-Artnet Packet", 13))

    
  if sendArtPollReply
    SendAPR
    sendArtPollReply := false

Pri CheckForDMX

  if byte[@InputMode] == DMX_Mode
    if DMX.isRunning
      ParseDMX
    Activity |= INA[DMXStatusLed]

Pri PrintState(nextState)

  fds.str(DEBUG, String("s: "))
  dio.decf(DEBUG, state, 3)
  fds.str(DEBUG, String(", n: "))
  dio.decf(debug, nextState, 3)
  fds.tx(debug, 13)

Pri PrintWebSocketStatus

  fds.str(DEBUG, String("WebSockStat: $"))
  dio.hex(DEBUG, Eth.SocketTCPstatus(webServerSocket), 2)
  fds.str(DEBUG, String(".", 13))

PRI PrintIterations

  if (cnt - timer) > (clkfreq*5)
    timer := cnt
    fds.str(DEBUG, String("Iterations: "))
    dio.dec(DEBUG, counter1)
    fds.str(DEBUG, String(", Artnet DMX parses: "))
    dio.dec(DEBUG, counter2)
    fds.str(DEBUG, String(".", 13))
    counter1 := 0
    counter2 := 0
  else
    counter1++
  '}
      
PUB HTMLConcat(_source)

  bytemove(@HTMLBuffer + strsize(@HTMLBuffer), _source, (strsize(_source)+1))

PUB checkInterrupts | returnVal, ready

  ready := true
    
  if WSInterrupt & Int_selectStyle OR WSInterrupt & Int_PixelCount
    WSInterrupt &= !Int_selectStyle
    WSInterrupt &= !Int_PixelCount
    startLEDs
    
  if WSInterrupt & Int_PortU
    byte[@APRSubAddr] := byte[@PortUniverse][0] & $F0
    WSInterrupt &= !Int_PortU
    fds.str(DEBUG, String("ArtNet SubNet Changed.", 13))
    
  if WSInterrupt & Int_PortS
    WSInterrupt &= !Int_PortS
    fds.str(DEBUG, String("LED Start Address Changed.", 13))
    
  if WSInterrupt & Int_defaults
    returnVal := saveDefaults
    if returnVal == -1
      fds.str(DEBUG, String("   Trouble saving defaults.", 13))
      WSInterrupt &= !Int_defaults
      'Beep / Create Status LED message for unsuccess.
    elseif returnVal == 0
      fds.str(DEBUG, String("Succesfully saved defaults.", 13))
      HTMLConcat(String("Succesfully saved default settings.<br>", 13, 10))      
      WSInterrupt &= !Int_defaults
      'Beep / Create Status LED message for success.

      
  if WSInterrupt & Int_selectInput
    if byte[@InputMode] == DMX_Mode
      if DMXControl(ENABLE) == 10
        HTMLConcat(String("No resources available for DMX input.", 13, 10))  
    else
      DMXControl(DISABLE) 
    WSInterrupt &= !Int_selectInput
    fds.str(DEBUG, String("Input Mode Changed.", 13))

  if WSInterrupt & Int_NetMode OR WSInterrupt & Int_IP OR WSInterrupt & Int_Subnet OR WSInterrupt & Int_Gateway
    validIP := FALSE
    if byte[@IPmode] == DynamicIP
      attemptDHCP := TRUE
    'nextState := IDLE
    WSInterrupt &= !Int_IP
    WSInterrupt &= !Int_Subnet
    WSInterrupt &= !Int_Gateway
    WSInterrupt &= !Int_NetMode
    fds.str(DEBUG, String("IP Settings Changed.", 13))
    ready := false
    
  {if WSInterrupt & Int_Renew
    attemptDHCP := TRUE
    validIP := FALSE
    WSInterrupt &= !Int_Renew
    fds.str(DEBUG, String("DHCP Requested.", 13))
    ready := false
   '}
  if ready  
    WSinterrupt &= !Int_Finished            'Finished

  'fds.str(DEBUG, String("WSInt: "))
  'dio.bin(DEBUG, WSInterrupt, 16)
  'fds.str(DEBUG, String(".", 13))
      
PUB statusLedControl | nextLEDStatusState
''This method updates the (4) LEDs on the front panel of the Node

  

  

  {if ValidIP == FALSE 'Set 4th LED (red) blinking
             'mode PLL        BPIN         APIN
    ctra := %00100_000 << 23 + 1 << 9 + StatLED4 'Establish mode and APIN (BPIN is ignored)
    frqa := $220 'Set FRQA so PHSA[31] toggles
    'dira[0] := 1 'Set APIN to output
  else  'Turn Off 4th (Red) LED
    ctrb := %00100_000 << 23 + 1 << 9 + StatLED3 'Establish mode and APIN (BPIN is ignored)
    frqb := $44 'Set FRQA so PHSA[31] toggles
    'OUTA[StatLED3]~~
    ctra := %00000_000
    '}
  nextLEDStatusState := LEDStatusState
  
  CASE LEDStatusState
    LEDStatusNormal:
      OUTA[StatLED1] := !INA[EthLk]  
      OUTA[StatLED2] := Activity <# 1
      LEDStatusTicks := cnt
      nextLEDStatusState := N1
    N1:
      OUTA[StatLED1] := !INA[EthLk]  
      OUTA[StatLED2] := Activity <# 1
      'Flash.flash(StatLED3, 50, 250)
               'mode PLL        BPIN         APIN
      phsa := 0
      ctra := %00100_000 << 23 + 1 << 9 + StatLED3 'Establish mode and APIN (BPIN is ignored)
      frqa := $200 'Set FRQA so PHSA[31] toggles
      'dira[0] := 1 'Set APIN to output
      nextLEDStatusState := N2
    N2:
      OUTA[StatLED1] := !INA[EthLk]  
      OUTA[StatLED2] := Activity <# 1
      if (cnt - LEDStatusTicks) => (clkfreq/4)
        'Flash.off
        ctra := %00000_000
        nextLEDStatusState := N3
    N3:
      OUTA[StatLED1] := !INA[EthLk]  
      OUTA[StatLED2] := Activity <# 1
      if (cnt - LEDStatusTicks) => (clkfreq)
        nextLEDStatusState := LEDStatusNormal    
        
    LEDResetState:
      LEDStatusTicks := cnt
      OUTA[StatLED1]~
      OUTA[StatLED2]~
      OUTA[StatLED3]~
      OUTA[StatLED4]~
      nextLEDStatusState := R1
    R1:
      OUTA[StatLED1]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R2
        LEDStatusTicks := cnt
    R2:
      OUTA[StatLED1]~
      OUTA[StatLED2]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R3
        LEDStatusTicks := cnt 
    R3:
      OUTA[StatLED2]~
      OUTA[StatLED3]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R4
        LEDStatusTicks := cnt 
    R4:
      OUTA[StatLED3]~
      OUTA[StatLED4]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R5
        LEDStatusTicks := cnt 
    R5:
      OUTA[StatLED4]~
      OUTA[StatLED3]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R6
        LEDStatusTicks := cnt 
    R6:
      OUTA[StatLED3]~
      OUTA[StatLED2]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R7
        LEDStatusTicks := cnt 
    R7:
      OUTA[StatLED2]~
      OUTA[StatLED1]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := R8
        LEDStatusTicks := cnt 
    R8:
      OUTA[StatLED1]~
      OUTA[StatLED2]~~
      if (cnt - LEDStatusTicks => clkfreq/4)
        nextLEDStatusState := LEDStatusNormal   



  Activity := 1
  {
  fds.str(DEBUG, String("s: "))
  dio.decf(DEBUG, LEDStatusState, 3)
  fds.str(DEBUG, String(", n: "))
  dio.decf(debug, nextLEDStatusState, 3)
  fds.tx(debug, 13)
  '}
  LEDStatusState := nextLEDStatusState
  
PUB parseArtAddress
''For Future Implementation
  
  return
    
PUB sendAPR | localIndex, returnVal

  bytemove(@APRIPAddr, @IPAddress, 4) 'Update IP address
  
  bytefill(@APROutput, 0, 4)
  repeat localIndex from 1 to numports <# 4
    if led[localIndex-1].running
      byte[@APROutput][localIndex-1] := %10000000
    else
      byte[@APROutput][localIndex-1] := %00000000

  byte[@APRSubAddr] := (byte[@PortUniverse][0] & $F0) >> 4
  
  repeat localIndex from 1 to numports <# 4
    byte[@APRSwOut][localIndex-1] := byte[@PortUniverse][localIndex-1] & $0F
    if byte[@PortPixelCount][localIndex-1] > 0 
      byte[@APRPortType][localIndex-1] := %1_0_000000
    else
      byte[@APRPortType][localIndex-1] := %0_0_000000

  if IPMode == DynamicIP
    byte[@APRStat2] := %00001111
  else
    byte[@APRStat2] := %00001101

  bytefill(@UDPPacket, 0, UDPPacketBufferLength)
  repeat localIndex from 0 to 3
    UDPPacket[localIndex] := byte[@IPAddress][localIndex] & byte[@SubnetMask][localIndex]
  repeat localIndex from 0 to 3
    UDPPacket[localIndex] |= !byte[@SubnetMask][localIndex]
  UDPPacket[4] := $19  'Dest Port
  UDPPacket[5] := $36
  UDPPacket[6] := $00  'Packet Length
  UDPPacket[7] := $EF
  bytemove(@UDPPacket[8], @ArtPollReply, 239)

  If validIP == TRUE
    'fds.str(DEBUG, String("Sending APR.", 13))
    return Eth.txUDP(artnetSocket, @UDPPacket)
  else
    return FALSE             

PRI ParseDMX | localIndex, length, start

  repeat localIndex from 0 to numPorts-1
    if byte[@PortUniverse][localIndex] == 0
      'Move Data and set update flag.
      length := 512
      if led[localIndex].running AND byte[_DMXBufferReady]
        start := word[@PortStartAddr][localIndex]
        length -= start
        bytemove(long[@ledColorAddr][localIndex], _DMXBufferAddress + start, length)
        byte[_DMXBufferReady] := 0    
  
PUB ParseArtDMX | Universe, Length, start, localIndex 

  length := 0             'Should I replace the [@APRSubAddr] reference with [@PortUniverse][0] & $F0 reference? 
                          'Yes, I believe so, now we don't have to update [@APRSubAddr] on powerup.                    
  'Determine if this node is on the same net this packet is intended for.
  if(byte[@APRNetAddr] == byte[@UDPPacket][UDPHeaderOffset+ArtDMXNetOffset])
    'Determine if this node is on the same Subnet this packet is intended for.
    'if((byte[@PortUniverse][0] & $F0) == (byte[@UDPPacket][UDPHeaderOffset+ArtDMXSubOffset] & $F0))
      'Determine which Universe this data is intended for.
    '  Universe := byte[@UDPPacket][UDPHeaderOffset+ArtDMXSubOffset] & $0F
      repeat localIndex from 0 to numPorts-1
        'if Universe == byte[@PortUniverse][localIndex] & $0F
        if byte[@UDPPacket][UDPHeaderOffset+ArtDMXSubOffset] == byte[@PortUniverse][localIndex]
          'Move Data and set update flag.
          length.byte[1] := byte[@UDPPacket][UDPHeaderOffset+ArtDMXLengthOffset]
          length.byte[0] := byte[@UDPPacket][UDPHeaderOffset+ArtDMXLengthOffset+1]
          if led[localIndex].running
            start := word[@PortStartAddr][localIndex]
            length -= start
            bytemove(long[@ledColorAddr][localIndex], @UDPPacket + UDPHeaderOffset + ArtDMXDataOffset + start, length)

  return length
  
PUB printIP(_addr)

  dio.Dec(DEBUG, byte[_addr][0])
  fds.Str(DEBUG, string("."))
  dio.Dec(DEBUG, byte[_addr][1])
  fds.Str(DEBUG, string("."))
  dio.Dec(DEBUG, byte[_addr][2])
  fds.Str(DEBUG, string("."))
  dio.Dec(DEBUG, byte[_addr][3])
  'fds.Str(DEBUG, string(DIO#NL))
   
  return

PUB HTMLConcatIP(_addr)

  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), num.dec(byte[_addr][0]), strsize(num.dec(byte[_addr][0])))'  dio.Dec(DEBUG, byte[_addr][0])
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), String("."), 1) 'fds.Str(DEBUG, string("."))
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), num.dec(byte[_addr][0]), strsize(num.dec(byte[_addr][1])))'  dio.Dec(DEBUG, byte[_addr][1])
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), String("."), 1) 'fds.Str(DEBUG, string("."))
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), num.dec(byte[_addr][0]), strsize(num.dec(byte[_addr][2])))'  dio.Dec(DEBUG, byte[_addr][2])
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), String("."), 1) 'fds.Str(DEBUG, string("."))
  bytemove(@HTMLBuffer+strsize(@HTMLBuffer), num.dec(byte[_addr][0]), strsize(num.dec(byte[_addr][3])))'  dio.Dec(DEBUG, byte[_addr][3])

  'fds.Str(DEBUG, string(DIO#NL))
   
  return
    
PRI Init | returnVal, temp
''This method serves to initiallize the WSE-SSD upon power-up
  
  'Start W5100 Driver
  returnVal := Eth.StartSPI(_scs, _sclk, _mosi, _miso, _reset)   
  fds.str(DEBUG, String("W5100 driver is running on cog "))
  dio.dec(DEBUG, returnVal)
  fds.tx(DEBUG, ".")
  fds.tx(DEBUG, 13)
  
  ETH.InitSocketMem( 4 )

  'Write MAC Address to W5100
  Eth.WriteMACaddress(true, @MACAddress)
   
  fds.Str(Debug, string("MAC Address: "))
  dio.hex(DEBUG, MACAddress[0], 2)
  fds.Str(DEBUG, string(":"))
  dio.hex(DEBUG, MACAddress[1], 2)
  fds.Str(DEBUG, string(":"))
  dio.hex(DEBUG, MACAddress[2], 2)
  fds.Str(DEBUG, string(":"))
  dio.hex(DEBUG, MACAddress[3], 2)
  fds.Str(DEBUG, string(":"))
  dio.hex(DEBUG, MACAddress[4], 2)
  fds.Str(DEBUG, string(":"))
  dio.hex(DEBUG, MACAddress[5], 2)
  fds.Str(DEBUG, string(DIO#NL))
     
  'Read EEPROM previous Data
  RecoverData

  'Set the Max RS485 receiver to RX mode.
  dira[DMXtxrxEn]~~          'Set DMX Tx/Rx pin an output
  outa[DMXtxrxEn]~           'Set DMX Tx/Rx pin Low.

  'Enable DMX Status LED as an output
  dira[DMXStatusLed]~~       'Set DMX Status LED pin an output 
  outa[DMXStatusLed]~        'Set DMX Status LED pin Low.      
   
  'Setup startup IPMode
  {if byte[@IPMode] == DynamicIP
    attemptDHCP := TRUE
  else
    attemptDHCP := FALSE
  '}
  'Initiallize Variables
  validIP := FALSE           'Start with invalid IP Address
  'DHCPtimer := 0  
  NewConnection := True
  sendArtPollReply := False

  'Update ArtPollReply parameters
  setupArtNet

  'Start LED Driver Cogs
  startLEDs
  
  fds.str(DEBUG, string("Initialized.", 13))

PRI setupArtNet | localIndex, tempAddr[4] 

  'update ArtPollReply data for this particular node.
  byte[@APRPortsHi] := 0
  byte[@APRPortsLo] := numPorts <# 4
  bytefill(@APRPortType, 0, 4)
  repeat localIndex from 1 to numports <# 4
    byte[@APRPortType][localIndex-1] := %1_0_000000

  bytemove(@APRMacAddr, @MacAddress, 6)
       
  'Open UDP Socket to listen for ArtPoll requests
  tempAddr[0] := 2           'I don't think this is neccessary for UDP
  tempAddr[1] := 255
  tempAddr[2] := 255
  tempAddr[3] := 255
  '   SocketOpen(_socket,      _mode,         _srcPort,   _destPort,  _destIP) 
  Eth.SocketOpen(artnetSocket, Eth#_UDPPROTO, artnetPort, artnetPort, @tempAddr)
  FDS.str(DEBUG, String("Opened Art-Net Socket.", 13))

PRI DMXControl(value) : returnVal
''This method controls the enabling and disabling of the dedicated DMX receiver Cog

  CASE value
    ENABLE:
      returnVal := DMX.init(DMXDataIn, DMXStatusLed, 0, 0)
      fds.str(DEBUG, String("DMX receiver is running on cog "))
      if returnVal > 0
        dio.dec(DEBUG, returnVal)
        _DMXBufferAddress := DMX.address
        _DMXBufferReady := _DMXBufferAddress + 513
      else
        fds.str(DEBUG, String("[NO COG]"))
        returnVal := 10
      fds.tx(DEBUG, ".")
      fds.tx(DEBUG, 13)

    DISABLE:
      if DMX.isRunning
        DMX.finalize
        fds.str(DEBUG, String("DMX receiver stopped.", 13))
    
PRI startLEDs : error | localIndex, rbswap, rgswap, LPDconvert, returnVal

  repeat localIndex from 0 to (numPorts-1)                 'For each Port
    fds.str(DEBUG, String("Starting LED driver for a "))
    rbswap := false                                        'Neither the Strip nor Strand need a swap of the red and blue values.
    if byte[@PortStyle][localIndex] == Strip_style         'If we are starting a driver for a Strip
      fds.str(DEBUG, String("strip "))
      rgswap := true                                       'We need to Swap Red and Green for the strip
      LPDconvert := true                                   'We need to convert the RGB values for the Strip
    else
      fds.str(DEBUG, String("strand "))
      rgswap := false                                      'The strand needs no conversion
      LPDconvert := false
    fds.str(DEBUG, String("of "))
    dio.dec(DEBUG, byte[@PortPixelCount][localIndex])
    fds.str(DEBUG, String(" pixels. "))
    if byte[@PortPixelCount][localIndex] > 0 AND byte[@PortDataPin][localIndex] <> -1 AND byte[@PortClockPin][localIndex] <> -1
      returnVal := led[localIndex].start(byte[@PortDataPin][localIndex], byte[@PortClockPin][localIndex], byte[@PortPixelCount][localIndex], LEDFrameDelay, rbswap, rgswap, LPDconvert)
      fds.str(DEBUG, String("(Cog "))
      dio.dec(DEBUG, returnVal)
      fds.str(DEBUG, String(")", 13))
      error |= returnVal
      long[@ledColorAddr][localIndex] := led[localIndex].address
    else
      led[localIndex].stop
      fds.str(DEBUG, String("(Stopped)", 13))
      
  return error


PRI MonitorSocket : nextState | temp[4], timeout
'' This routine constantly monitors the status of the WebServerSocket on the W5100
    
  nextState := IDLE
   
  CASE Eth.SocketTCPstatus(webServerSocket)
    Eth#_SOCK_CLOSED    :              'WebServerSocket is Closed and not listening.
      SetUpWebServer                   'Ensure WebServer is running and begin listening.
      NewConnection := True            'The next time we find the Socket Established, it will be a new connection.
    Eth#_SOCK_INIT      :
      ' This is taken care of by SetUpWebServer Method.
    Eth#_SOCK_LISTEN    :
      ' Waiting for connection. [IDLE]
        socketTimer := cnt             'Reset Socket Timeout variable 
    Eth#_SOCK_ESTAB     :
      if NewConnection == True         'Is this a new connection?
        NewConnection := False
        socketTimer := cnt
        Eth.SocketTCPGetDestAddr(webServerSocket, @temp[0])    'display who we are connected to 
        fds.str(DEBUG, String("Connection established with "))
        printIP(@temp)
        fds.str(DEBUG, String(".", 13)) 
      elseif !WEB.isBusy               'If the webServer is Idle, why are we still connected?
        if checkDataPresent            'Check for received TCP Data.
          socketTimer := cnt
          nextState := DataForWebserver
          'fds.str(DEBUG, @HTMLBuffer)
        elseif (cnt - socketTimer) > (clkfreq/1000 * SocketCloseDelay) 'Wait specified delay period for Client to disconnect
          Eth.SocketTCPdisconnect(webServerSocket)                     'Manually Disconnect the idle connection
          'Eth.SocketClose(webServerSocket)
          fds.str(DEBUG, String("Connection Disconnected.", 13))
          sockWaitTimer := cnt 
      else
        socketTimer := cnt             'Webserver is busy, keep the connection open.
     
    Eth#_SOCK_CLOSE_WT  :
      ' The client would like to disconnect.
      Eth.SocketTCPdisconnect(webServerSocket)   'Acknoledge the request by disconnecting.
      fds.str(DEBUG, String("Client Disconnected.", 13))
      sockWaitTimer := cnt
      ' W5100 will automatically go to Closed State.
      
    Eth#_SOCK_UDP       :
    Eth#_SOCK_IPRAW     :
    Eth#_SOCK_MACRAW    :
    Eth#_SOCK_PPPOE     :
    Eth#_SOCK_SYNSENT   :
      ' Inter-status state. Only used for TCP Connect command.
    Eth#_SOCK_SYNRECV   :
      ' Inter-status state. This state is used when receiving a connection from a client.
    Eth#_SOCK_FIN_WAIT  :
      ' Inter-status states. Used in process of connection termination.
      if (cnt - sockWaitTimer) > (clkfreq/1000 * SocketCloseDelay)   'Wait specified delay period for W5100 to close the connection.
        Eth.SocketClose(webServerSocket)                             'If W5100 is too slow, manually Close the connection.
    Eth#_SOCK_CLOSING   :
    Eth#_SOCK_TIME_WAIT :
    Eth#_SOCK_LAST_ACK  :
    Eth#_SOCK_ARP1      :
      ' Inter-status states. Only used when Sending connection requests or send UDP Data. 
    Eth#_SOCK_ARP2      :
    Eth#_SOCK_ARP3      :

  return

{PRI tryDHCP : returnVal

  'Start DHCP Process
  DHCP.Start
  DHCP.SetHostName(@HostName)
  DHCP.SetMAC_Address(@MACaddress)  

  returnVal := DHCP.DoDHCP(DHCPSocket, $4242_4242)

  return 
'}
PRI RecoverData

''  Read saved data from EEProm

  D2E.readBlock(EeMACaddress, @MACaddress)
  D2E.readBlock(EeGatewayAddress, @GatewayAddress)
  D2E.readBlock(EeSubnetMask, @SubnetMask)
  D2E.readBlock(EeIPAddress, @IPAddress)

  D2E.readBlock(EeIPMode, @IPMode)
  D2E.readBlock(EeInputMode, @InputMode)
  D2E.readBlock(EePortUniverse, @PortUniverse)
  D2E.readBlock(EePortStartAddr, @PortStartAddr)
  D2E.readBlock(EePortStyle, @PortStyle)
  D2E.readBlock(EePortPixelCount, @PortPixelCount)

PRI saveDefaults : error | localIndex
''  Write data to EEprom for later recovery

  error := 0 

  I2C.Initialize(I2C#BootPin)
     
  'Write Ram data to EEPROM
  repeat localIndex from 0 to 3 
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EeGatewayAddress+2+localIndex, GatewayAddress[localIndex])
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EeSubnetMask+2+localIndex, SubnetMask[localIndex])
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EeIPAddress+2+localIndex, IPAddress[localIndex])
   
  error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EeIPMode+2, IPMode)
  error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EeInputMode+2, InputMode)
   
  repeat localIndex from 0 to numPorts-1
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EePortUniverse+2+localIndex, PortUniverse[localIndex])
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EePortStartAddr+2+localIndex*2, word[@PortStartAddr][localIndex] & $FF)
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EePortStartAddr+2+localIndex*2+1, (word[@PortStartAddr][localIndex] >> 8) & $FF)
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EePortStyle+2+localIndex, PortStyle[localIndex])
    error |= I2C.WriteByte(I2C#BootPin, I2C#EEPROM, EePortPixelCount+2+localIndex, PortPixelCount[localIndex])
   
     
  return error
  
PRI SetupWebServer | tempData[4], returnVal

''  Start webserver if not already running, and prepare W5100 to listen for connections.

  if !WEB.isRunning
    returnVal := WEB.Start(@HTMLBuffer, HTMLBufferSize, numPorts, @MACaddress, @WSInterrupt)
    fds.str(DEBUG, String("WebServer is running on cog "))
    dio.dec(DEBUG, returnVal)
    fds.tx(DEBUG, ".")
    fds.tx(DEBUG, 13)

  if NetworkUploadPending == True
    UploadNetworkSettings
    NetworkUploadPending := False
      
  tempData[0] := 0       'I don't think this is necessary if we are only listening.
  tempData[1] := 0
  tempData[2] := 0
  tempData[3] := 0
  Eth.SocketOpen(webServerSocket, Eth#_TCPPROTO, webServerListenPort, webServerListenPort, @tempData)
  Eth.SocketTCPlisten(webServerSocket)
  fds.str(DEBUG, String("WebServerSocket Listening.", 13))

PRI checkDataPresent
''  Check the W5100 for data on the WebServerSocket and retreive.

  if Eth.rxTCP(webServerSocket, @HTMLBuffer) <> 0
    return true
  else
    return false
    
PUB UploadNetworkSettings | localIndex, tempAddr[4]
''  Write ethernet parameters to W5100 from RAM. 
 
  Eth.WriteGatewayAddress(true, @GatewayAddress)
  Eth.WriteSubnetMask(true, @SubnetMask)
  Eth.WriteIPAddress(true, @IPAddress)
  fds.str(DEBUG, String("Uploaded Network Settings.", 13))

  return

PUB DownloadNetworkSettings | localIndex, tempAddr[4]
''  Read ethernet parameters from W5100 and store in RAM. 
 
  Eth.ReadIPaddress(@IPAddress)
  Eth.ReadSubnetMask(@SubnetMask)
  Eth.ReadGatewayAddress(@GatewayAddress)

  return
  
pub pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1792                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
      
DAT

        ' Port Data/Clock Pin Assignments
        '                    0,  1,  2,  3,  4,  5,  6,  7
        PortDataPin   byte  19, 15, 24, 24, -1, -1, -1, -1
        PortClockPin  byte  18, 14, 24, 24, -1, -1, -1, -1

        HostName         byte "WSE-SSD", 0
         
        MACaddress       byte      $00, $08, $DC, $09, $09, $86  'Hard Coded
        GatewayAddress   byte        0,   0,   0,   0
        SubnetMask       byte      255,   0,   0,   0
        IPAddress        byte        0,   0,   0,   0
         
        IPMode           byte   StaticIP
        InputMode        byte   DMX_mode
        PortUniverse     byte   $00[numPorts] 
        PortStartAddr    word   $0000[numPorts]
        PortStyle        byte   $00[numPorts]
        PortPixelCount   byte   $00[numPorts]

        HTMLBuffer    byte  $00[HTMLBufferSize]



        UDPPacket     byte $00[UDPPacketBufferLength]
        'DMXU0         byte $00[DMXUniverseBufferLength]
        'DMXU1         byte $00[DMXUniverseBufferLength]
        'DMXU2         byte $00[DMXUniverseBufferLength]
        'DMXU3         byte $00[DMXUniverseBufferLength]


ArtPoll       byte "Art-Net", $00   ' Identifier
              word $2000            ' OpCode: OpPoll
              byte $00              ' Art-Net Protocal Version High Byte
              byte $0E              ' Art-Net Protocal Version Low Byte
              byte %0000_0000       ' TalkToMe parameters.
              byte $00              ' Priority
          
'236 byte payload, 8 byte header
ArtPollReply  byte "Art-Net", $00   ' Identifier
APRopCode     word $2100            ' OpCode: OpPollReply   *Transmitted LOW byte first
APRIPAddr     byte 002, 009, 009, 086               ' Current Node IP Address
APRport       word $1936            ' UDP port              *Transmitted LOW byte first
APRFWhi       byte $01              ' FWVersion High Byte
APRPWlo       byte $00              ' FWVersion Low Byte
APRNetAddr    byte %0_0000000       ' Port-Address High (Net)
APRSubAddr    byte %0000_0000       ' Port-Address Low  (Sub-Net / Universe)
APROemHi      byte $FF              ' Oem value Hi
APROemLo      byte $FF              ' Oem Value Low
APRBIOS       byte $00              ' FWVersion of User Bios Extension Area
APRStatus     byte %11_00_0_0_0_0   ' General Status Register
APREstaLo     byte $00              ' Esta Manufacturer Low byte
APREstaHi     byte $00              ' Esta Manufacturer High Byte
APRNameS      byte "WorldStage Node", 0, 0, 0           ' Short Name 
APRNameL      byte "WorldStage-East Art-Net Node for driving WSE-S25/WSE-S32 LEDs", 0, 0, 0                     ' Long Name
APRText       byte $00[64]                     ' Textual Status Report
APRPortsHi    byte $00              ' Number of Ports High Byte
APRPortsLo    byte $02              ' Number of Ports Low Byte
APRPortType   byte %1_0_000000      ' Port type [1]
              byte %1_0_000000      ' Port type [2] 
              byte %1_0_000000      ' Port type [3] 
              byte %1_0_000000      ' Port type [4]
APRInput      byte %0_0_0_0_1_0_0_0 ' Good Input [1]
              byte %0_0_0_0_1_0_0_0 ' Good Input [2]
              byte %0_0_0_0_1_0_0_0 ' Good Input [3]
              byte %0_0_0_0_1_0_0_0 ' Good Input [4]
APROutput     byte %1_0_0_0_0_0_0_0 ' Good Output [1]
              byte %1_0_0_0_0_0_0_0 ' Good Output [2]
              byte %1_0_0_0_0_0_0_0 ' Good Output [3]
              byte %1_0_0_0_0_0_0_0 ' Good Output [4]
APRSwIn       byte %0000_0000       ' Switch In [1]
              byte %0000_0000       ' Switch In [2]
              byte %0000_0000       ' Switch In [3]
              byte %0000_0000       ' Switch In [4] 
APRSwOut      byte %0000_0000       ' Switch Out [1]
              byte %0000_0000       ' Switch Out [2]
              byte %0000_0000       ' Switch Out [3]
              byte %0000_0000       ' Switch Out [4]
APRVidSw      byte $00              ' Video Switch
APRMacro      byte %00000000        ' Macro activity
APRRemote     byte %00000000        ' Remote activity
              byte $00              ' Spare
              byte $00              ' Spare
              byte $00              ' Spare
APRStyle      byte $00              ' Style: A DMX to/from Art-Net device
APRMacAddr    byte $00, $08, $DC, $09, $09, $86     'MAC Address
APRIPBind     byte $00, $00, $00, $00               'IP of root device
APRIdxBind    byte $00              ' Bind Index
APRStat2      byte %0000_1_0_0_0    'Status 2
              byte $00[26]