CON

{

  This is a state-machine driver version of the webserver.
  No data is sent or received from this module using the Eth object.
  This module packages and parses the data for the Eth object in the main thread.



  Top section is the state maching controller
  Bottom section is the state maching executer.

  TODO:









}

  DEBUG = 0

  '----------------------------------------------------
  ' WebServer State Machine Constants

  Initialize    = 1
  Idle          = 2
  ReadHeader    = 3
  
  GetSlash      = 50
  GetFavIcon    = 51
  GetNotFound   = 52
  Head          = 53
  Post          = 54
  UnknownHeader = 55
  
  ReadPost      = 71
  PostNoDataContinue = 72 
  PostNoData    = 73
  PostData      = 74
  
  PostParse      = 80
  
  ParseResponse = 100
  
  GenHTTPheader = 110
  GenHTML1      = 111
  GenHTML2      = 112
  WaitForDemo   = 113  
      
  flush           = 120  

  Default       = 0
  '------------------------------------------------------



  ' Upper EEPROM Address Constants
  httpHeader = $8100
  httpContinue = $8146
  httpAccept = $8162
  httpNoContent = $81C2
  httpNotFound = $8222
  httpNotImplemented = $8280
  htmlheader = $82E4
  htmlBody = $8338
  htmlSelected = $83B4
  htmlNetSetting = $83CB
  htmlNetSettingA = $841B
  htmlNetSettingB = $844A
  htmlNetSettingC = $847D
  htmlNetSettingD = $84B7
  htmlDHCPButton = $84E2
  htmlStaticIPInput = $8522
  htmlStaticIPInputA = $8572
  htmlStaticIPInputB = $85A8
  htmlStaticIPInputC = $85DE
  htmlStaticIPInputD = $8614
  htmlStaticIPInputE = $8678
  htmlStaticIPInputF = $86B2
  htmlStaticIPInputG = $86EC
  htmlStaticIPInputH = $8726
  htmlStaticIPInputJ = $878E
  htmlStaticIPInputK = $87C9
  htmlStaticIPInputL = $8804
  htmlStaticIPInputM = $883F
  htmlInputMode = $8868
  htmlInputModeA = $88B3
  htmlInputModeB = $88DD
  htmlInputModeC = $8903
  htmlUniverse = $8928
  htmlUniverseA = $8944
  htmlUniverseB = $8994
  htmlUniverseC = $89A0
  htmlUniverseD = $89F2
  htmlUniverseE = $89FE
  htmlUniverseF = $8A49
  htmlUniverseG = $8A65
  htmlUniverseH = $8A99
  htmlUniverseJ = $8B11
  htmlUniverseK = $8B1D
  htmlClose = $8B2F
  WSfavicon = $8C03
'}
  ' Name Hash codes
  hash_NetMode = $2BB9CA8F
  code_NetMode = 1
  hash_selectInput = $3ACD1FCF
  code_selectInput = 2
  hash_IP = $4876EE32
  code_IP = 3
  hash_Subnet = $F2C386D2
  code_Subnet = 4
  hash_Gateway = $A38CA46D
  code_Gateway = 5
  hash_button = $3A42C455
  code_button = 6
  code_portU = 7
  code_portS = 8
  code_style = 9
  code_PixelCount = 10

  
  ' Value Hash Codes
  hash_static = $540353F7
  hash_dynamic = $8489FD3C
  hash_artnet = $45B458B5
  hash_sacn = $3AE9A8FA
  hash_dmx = $1E95395C
  hash_Renew = $5140D4C2
  hash_strip = $4D42124D
  hash_strand = $D1EF1EF5

  'Hash constants
  FNV_PRIME     = 16777619
  FNV_OFFSET    = 2166136261
  
  'PostedChanges
  Int_NetMode     = %00000000_00000001
  Int_selectInput = %00000000_00000010
  Int_IP          = %00000000_00000100
  Int_Subnet      = %00000000_00001000
  Int_Gateway     = %00000000_00010000
  Int_portU       = %00000000_00100000
  Int_portS       = %00000000_01000000
  Int_selectStyle = %00000000_10000000
  Int_PixelCount  = %00000001_00000000
  Int_Renew       = %00000010_00000000
  Int_defaults    = %00000100_00000000
  Int_Ready       = %01000000_00000000
  Int_Finished    = %10000000_00000000
  
  'HTMLCommand Constants:
  CLEAR         = 0
  GET_LENGTH     = 1
  UPDATE_HEADER_LENGTH = 2
  
  'Outside commands:
  nocommand     = 0
  ReceivedHTML  = 2

  QUERY = 0
  RESET = 1

    'IPMode/InputStatus
  StaticIP  = 0
  DynamicIP = 1
  NetworkOff = 2
  NetworkOn  = 3
  DMX_mode    = 0
  ArtNet_mode = 1
  sACN_mode   = 2
  Strip_style       = 0 'LPD8806 
  Strand_style      = 1 'WS2801


  'Arguments
  MacaddressOffset     = 0
  GatewayAddressOffset = 6
  SubnetMaskOffset     = 10
  IPAddressOffset      = 14
  IPModeOffset         = 18
  InputModeOffset      = 19
  PortUniverseOffset   = 20

  FavIconLength = 908

  MaxPixelCount = 170

  TempStringSize = 20
  
OBJ

  D2E      : "DAT to EEPROM 10.2.12.spin"
  NUM      : "Simple_Numbers.spin"
  Str      : "ASCII0_STREngine.spin"
  
  FDS      : "fullDuplexSerial4port.spin" 
  DIO      : "dataIO4port.spin"

  'STK   :       "Stack Length.spin"
  
VAR
  long cog          'Cog ID
  long state
  long nextState
  long holdState
  long _HTMLBuffer
  long HTMLBufferSize
  long _Arguments
  long _interrupt
  
  byte resetstate  
  byte command
  long fromPost

  long PortStartAddrOffset                                          
  long PortStyleOffset            
  long PortPixelCountOffset

  byte numPorts

  long dataLength
  byte StringBuffer[100]
  long stack1[100]

PUB Start(_HTMLBufferAddr, bufferSize, Portcount, _Args, _WSinterrupt) : Okay | localIndex

  Stop                                 'Stop previous instance of Web Server

  _interrupt := _WSinterrupt           'Store value of interrupt register
  
  _HTMLBuffer := _HTMLBufferAddr       'Store value of HTMLBuffer register
  HTMLBufferSize := bufferSize         'Store value of HTMLBuffer size
  numPorts := Portcount                'Store number of ports
  _Arguments := _Args                  'Store the starting address of Arguments
  
  PortStartAddrOffset     := PortUniverseOffset + numPorts                         'Calculate PortStarAddrOffset                
  PortStyleOffset         := PortUniverseOffset + numPorts + numPorts*2            'Calculate PortStyleOffset
  PortPixelCountOffset    := PortUniverseOffset + numPorts + numPorts*2 + numPorts 'Calculate PortPixelCountOffset

  state := Initialize
  command := 0
  resetstate := 0
  
  'STK.Init(@stack1, 200)
  okay := cog := cognew(stateMachine, @stack1) + 1

  return

PUB Stop

'' Stop WebServer driver - frees a cog

  if cog
    state := IDLE
    long[_interrupt] := 0   'Clear all interrupts
    cogstop(cog~ - 1)

PUB stateMachine | returnVal, temp       'WebServer State Machine
  
  repeat
  
    CASE state
      Initialize    :
        nextState := IDLE
      
      Idle          :
        'Waiting for command.
        CASE command
          ReceivedHTML:
            nextState := ReadHeader
            'fds.str(debug, string(" Recieved HTML command", 13))
            command := nocommand
          OTHER:
            nextState := IDLE 
            
      ReadHeader    :
        CASE parseHeader    
          GetSlash:
            nextState := GenHTTPheader
          GetNotFound, Head:
            dataLength := strsize(_HTMLBuffer)
            nextState := flush
            holdState := IDLE
          GetFavIcon:
            dataLength := FavIconLength
            nextState := flush
            holdState := IDLE         
          Post:
            nextState := ReadPost
          UnknownHeader:
            dataLength := strsize(_HTMLBuffer) 
            nextState := flush
            holdState := IDLE

          
      ReadPost:
        CASE parsePostHeader
          PostNoDataContinue:
            nextState := flush
            holdState := IDLE
          PostNoData:
            nextState := Idle     
          PostData:
            nextState := PostParse
            
      PostParse:
        long[_interrupt] |= parsePostData
        fromPost := true
        nextState := GenHTTPheader

      GenHTTPheader:
        generateHTTPheader
        generateHTMLpart1a 
        if fromPost
          'fds.str(DEBUG, String(" Setting Int_Ready.", 13))
          long[_interrupt] |= (Int_Ready | Int_Finished)
          fromPost := false
        nextState := waitForDemo

      WaitForDemo:
        'Wait for DEMO to finish adding Strings
        if long[_interrupt] == 0
          'fds.str(DEBUG, String(" INT RESET", 13))
          dataLength := strsize(_HTMLBuffer)
          holdState := GenHTML1
          nextState := flush
        else
          nextState := WaitForDemo
          
      GenHTML1:
        generateHTMLpart1b
        temp := 0
        holdState := GenHTML2
        nextState := flush
        
      GenHTML2:
        {fds.str(DEBUG, String("Stack Used: "))
        dio.dec(DEBUG, Stk.GetLength(0, 0))
        fds.str(DEBUG, String(".", 13))}
        if (temp := generateHTMLpart2(temp+1)) > 0
          holdState := GenHTML2
          nextState := flush
        else
          holdState := IDLE
          nextState := flush

      flush:
        'wait for data to be sent 
        if resetstate == 1
          HTMLBufferControl(CLEAR)
          nextState := holdState
          holdState := IDLE
          resetstate := 0
        else
          nextState := flush
          
      Other:
        nextState := IDLE


    state := nextState

PUB setCommand(value)

  if command == nocommand
    command := value

PUB isRunning

  if cog
    return true
  else
    return false

PUB isBusy

  If state == Idle
    return false
  else
    return true

PUB isReadyToSend(value) : result

  CASE value
    QUERY:
      If state == flush
        result := true
      else  
        result := false
    RESET:
      If state == flush 
        resetstate := 1

  return
  
PUB getDataLength

  return dataLength

PUB parseHeader
 
  if InStr(0,_HTMLBuffer, string("GET ")) == 0
    if InStr(4,_HTMLBuffer, string("/ ")) == 4
      if InStr(6,_HTMLBuffer, string("HTTP/1.")) == 6
        return GetSlash
    elseif InStr(4,_HTMLBuffer, string("/favicon.ico ")) == 4
      HTMLBufferControl(CLEAR)
      HTMLBufferConcatFromEEPROM(WSfavicon)
      return GetFavIcon
    else
      HTMLBufferControl(CLEAR)
      HTMLBufferConcatFromEEPROM(httpNotFound)
      return GetNotFound

  elseif InStr(0,_HTMLBuffer, string("HEAD ")) == 0 
    HTMLBufferControl(CLEAR)
    HTMLBufferConcatFromEEPROM(httpHeader)
    return Head
    
  elseif InStr(0, _HTMLBuffer, string("POST ")) == 0
    if InStr(5, _HTMLBuffer, string("/ ")) == 5         
      return Post
      
  else
    HTMLBufferControl(CLEAR)
    HTMLBufferConcatFromEEPROM(httpNotImplemented)
    return UnknownHeader

PUB parsePostHeader | rxLength, temp

  rxLength := strsize(_HTMLBuffer)
  temp := InStr(0,_HTMLBuffer, string(13, 10, 13, 10))
   
  if (rxLength - temp =< 4) 'wait for next packet for data...   
    if (InStr(0, _HTMLBuffer, string("Expect: 100-continue")) <> -1)
      HTMLBufferControl(CLEAR)
      HTMLBufferConcatFromEEPROM(httpContinue)
      return PostNoDataContinue      
      'READY TO TRANSMIT
    else
      'fds.str(DEBUG, STRING("Expecting additional info...", 13))
      return PostNoData  
  else
    return PostData

PUB generateHTTPheader
  'prepare to send main page.
  HTMLBufferControl(CLEAR)                                   'Clear buffer.
  HTMLBufferConcatFromEEPROM(httpHeader)
  dataLength := strsize(_HTMLBuffer)
  return

PUB generateHTMLpart1a | localIndex

  HTMLBufferControl(CLEAR)                                  'Clear buffer.
  HTMLBufferConcatFromEEPROM(htmlheader)
  HTMLBufferConcatFromEEPROM(htmlBody)
  return

PUB generateHTMLpart1b | localIndex

  HTMLBufferConcatFromEEPROM(htmlNetSetting)
   
  'create IPMode select list    
  CASE byte[_Arguments + IPModeOffset]
     
    StaticIP:
      HTMLBufferConcatFromEEPROM(htmlSelected) 'set  
      HTMLBufferConcatFromEEPROM(htmlNetSettingA)
      HTMLBufferConcatFromEEPROM(htmlNetSettingB)
      HTMLBufferConcatFromEEPROM(htmlNetSettingC)
      HTMLBufferConcatFromEEPROM(htmlNetSettingD)
        'create textfields for user supplied IP information.
      HTMLBufferConcatFromEEPROM(htmlStaticIPInput)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + IPAddressOffset][0]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputA)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + IPAddressOffset][1]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputB)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + IPAddressOffset][2]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputC)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + IPAddressOffset][3]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputD)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + SubnetMaskOffset][0]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputE)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + SubnetMaskOffset][1]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputF)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + SubnetMaskOffset][2]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputG)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + SubnetMaskOffset][3]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputH)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + GatewayAddressOffset][0]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputJ)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + GatewayAddressOffset][1]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputK)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + GatewayAddressOffset][2]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputL)
      HTMLBufferConcatFromRam(num.dec(byte[_Arguments + GatewayAddressOffset][3]))
      HTMLBufferConcatFromEEPROM(htmlStaticIPInputM)

    {DynamicIP:
      HTMLBufferConcatFromEEPROM(htmlNetSettingA)
      HTMLBufferConcatFromEEPROM(htmlSelected)              
      HTMLBufferConcatFromEEPROM(htmlNetSettingB)
      HTMLBufferConcatFromEEPROM(htmlNetSettingC)
      HTMLBufferConcatFromEEPROM(htmlNetSettingD)
      HTMLBufferConcatFromEEPROM(htmlDHCPButton)
    '}  
    NetworkOff:
      HTMLBufferConcatFromEEPROM(htmlNetSettingA)           
      HTMLBufferConcatFromEEPROM(htmlNetSettingB)
      HTMLBufferConcatFromEEPROM(htmlSelected)   
      HTMLBufferConcatFromEEPROM(htmlNetSettingC)
      HTMLBufferConcatFromEEPROM(htmlNetSettingD)
      
    NetworkOn:
      HTMLBufferConcatFromEEPROM(htmlNetSettingA)           
      HTMLBufferConcatFromEEPROM(htmlNetSettingB)
      HTMLBufferConcatFromEEPROM(htmlNetSettingC)
      HTMLBufferConcatFromEEPROM(htmlNetSettingD)
      HTMLBufferConcatFromEEPROM(htmlSelected)   

  HTMLBufferConcatFromEEPROM(htmlInputMode)
    'Create InputMode select list
  CASE byte[_Arguments + InputModeOffset]
    DMX_mode:
      HTMLBufferConcatFromEEPROM(htmlInputModeA)
      HTMLBufferConcatFromEEPROM(htmlInputModeB)
      HTMLBufferConcatFromEEPROM(htmlSelected)
    sACN_mode:
      HTMLBufferConcatFromEEPROM(htmlInputModeA)
      HTMLBufferConcatFromEEPROM(htmlSelected)
      HTMLBufferConcatFromEEPROM(htmlInputModeB)
    ArtNet_mode:
      HTMLBufferConcatFromEEPROM(htmlSelected)
      HTMLBufferConcatFromEEPROM(htmlInputModeA)
      HTMLBufferConcatFromEEPROM(htmlInputModeB)
  HTMLBufferConcatFromEEPROM(htmlInputModeC)        
  'fds.str(debug, string("Generated HTML Part1.", 13))
  dataLength := strsize(_HTMLBuffer)
  return

PUB generateHTMLpart2(value) | localIndex
  ''Value is the port number to start with.
  ''Returns the last port that HTML was generated for before the buffer filled.
  ''Returns 0 if generation is complete.
  
  result := 0
          
  repeat localIndex from value to numPorts
    if value > numPorts
      quit
    HTMLBufferConcatFromEEPROM(htmlUniverse)
    HTMLBufferConcatFromRam(num.dec(localIndex))
    HTMLBufferConcatFromEEPROM(htmlUniverseA)
    HTMLBufferConcatFromRam(num.dec(localIndex))
    HTMLBufferConcatFromEEPROM(htmlUniverseB)
    HTMLBufferConcatFromRam(num.dec(byte[_Arguments + PortUniverseOffset][localIndex-1]+1))
    HTMLBufferConcatFromEEPROM(htmlUniverseC)
    HTMLBufferConcatFromRam(num.dec(localIndex))
    HTMLBufferConcatFromEEPROM(htmlUniverseD) 
    HTMLBufferConcatFromRam(num.dec(word[_Arguments + PortStartAddrOffset][localIndex-1]+1))
    HTMLBufferConcatFromEEPROM(htmlUniverseE)
    HTMLBufferConcatFromRam(num.dec(localIndex))
    HTMLBufferConcatFromEEPROM(htmlUniverseF)
    CASE byte[_Arguments + PortStyleOffset][localIndex-1]
      Strip_style:
        HTMLBufferConcatFromEEPROM(htmlSelected)
        HTMLBufferConcatFromEEPROM(htmlUniverseG)
      Strand_style:
        HTMLBufferConcatFromEEPROM(htmlUniverseG)
        HTMLBufferConcatFromEEPROM(htmlSelected)
    HTMLBufferConcatFromEEPROM(htmlUniverseH)
    HTMLBufferConcatFromRam(num.dec(localIndex))
    HTMLBufferConcatFromEEPROM(htmlUniverseJ)
    HTMLBufferConcatFromRam(num.dec(byte[_Arguments + PortPixelCountOffset][localIndex-1]))
    HTMLBufferConcatFromEEPROM(htmlUniverseK) 
    
    if(HTMLBufferControl(GET_LENGTH) => 1500)
      dataLength := strsize(_HTMLBuffer)
      return localIndex
  
  HTMLBufferConcatFromEEPROM(htmlClose)
  'HTMLBufferControl(UPDATE_HEADER_LENGTH)'Update header length
  dataLength := strsize(_HTMLBuffer)
  
  return
   
PUB parsePostData : result | temp1, temp2, tempName[TempStringSize], tempValue[TempStringSize], returnVal, portValue, done

  result := 0
  done := FALSE
  temp2 := InStr(0, _HTMLBuffer, string(13, 10, 13, 10)) + 3  'Put string Pointer 2 at the end of the double-break

  repeat
    bytefill(@tempName, 0, TempStringSize)                       'Clear the Name array.
    temp1 := temp2 + 1                                           'Get the location of the beginning of the next Name.
    temp2 := InStr(temp1, _HTMLBuffer, string("="))              'Get the location of the Name/Value delimiter.
    bytemove(@tempName, _HTMLBuffer+temp1, (temp2-temp1) <# TempStringSize) 'Copy the string to the Name array.
    bytefill(@tempValue, 0, TempStringSize)                      'Clear the Value array.
    temp1 := temp2 + 1                                           'Get the location of the beginning of the Value.
    if (temp2 := InStr(temp1, _HTMLBuffer, string("&"))) == -1   'Test for presence of the Name/Value Pair delimiter.
      temp2 := temp1                                             ' If this doesn't exist, start at the last location
      repeat while byte[_HTMLBuffer+(++temp2)] <> 0              ' and locate the end of the String Buffer.
      done := true                                               ' Signify that this is the last iteration.
    bytemove(@tempValue, _HTMLBuffer+temp1, (temp2-temp1) <# TempStringSize) 'Copy the string to the Value Array
     
    Case GetNameCode(@tempName)                                  'Lookup the hashed code of the Name
      code_NetMode:                                              
        if strcomp(@tempValue, string("static"))                 'Compare string to known value
          if byte[_Arguments + IPModeOffset] <> StaticIP         'Test if new value is different
            byte[_Arguments + IPModeOffset] := StaticIP          'Set new value
            result |= Int_NetMode                             'Set interrupt flag
        {elseif strcomp(@tempValue, string("dynamic"))
          if byte[_Arguments + IPModeOffset] <> DynamicIP
            byte[_Arguments + IPModeOffset] := DynamicIP
            result |= Int_NetMode  '}
        elseif strcomp(@tempValue, string("NetworkOff"))
          if byte[_Arguments + IPModeOffset] <> NetworkOff
            byte[_Arguments + IPModeOffset] := NetworkOff
            result |= Int_NetMode
        elseif strcomp(@tempValue, string("NetworkOn"))
          if byte[_Arguments + IPModeOffset] <> NetworkOn
            byte[_Arguments + IPModeOffset] := NetworkOn
            result |= Int_NetMode
                       
      code_selectInput:
        if strcomp(@tempValue, string("artnet"))
          if byte[_Arguments + InputModeOffset] <> ArtNet_mode
            byte[_Arguments + InputModeOffset] := ArtNet_mode
            result |= Int_selectInput
        elseif strcomp(@tempValue, string("sacn"))
          if byte[_Arguments + InputModeOffset] <> sACN_Mode
            byte[_Arguments + InputModeOffset] := sACN_Mode
            result |= Int_selectInput
        elseif strcomp(@tempValue, string("dmx"))
          if byte[_Arguments + InputModeOffset] <> dmx_Mode
            byte[_Arguments + InputModeOffset] := dmx_Mode
            result |= Int_selectInput
           
      code_button:
        {if strcomp(@tempValue, string("Renew+DHCP"))
          fds.str(DEBUG, String("Renewing DHCP.", 13))
          result |= Int_renew'}
        if strcomp(@tempValue, string("Save+defaults"))
          result |= Int_defaults

      code_portU:
        portValue := Str.decimalToInteger(@tempName+5) - 1       'Get portnumber from name and convert to port value
        if byte[_Arguments + PortUniverseOffset][portValue] <> (1 #> Str.decimalToInteger(@tempValue) <# 256)-1   
          byte[_Arguments + PortUniverseOffset][portValue] := (1 #> Str.decimalToInteger(@tempValue) <# 256)-1
          result |= Int_portU
     
      code_portS:
        portValue := Str.decimalToInteger(@tempName+5) - 1
        if word[_Arguments + PortStartAddrOffset][portValue] <> (1 #> Str.decimalToInteger(@tempValue) <# 512)-1
          word[_Arguments + PortStartAddrOffset][portValue] := (1 #> Str.decimalToInteger(@tempValue) <# 512)-1
          result |= Int_portS
     
      code_style:
        portValue := Str.decimalToInteger(@tempName+11) - 1
        if strcomp(@tempValue, string("strip"))
          if byte[_Arguments + PortStyleOffset][portValue] <> Strip_Style
            byte[_Arguments + PortStyleOffset][portValue] := Strip_Style
            result |= Int_selectStyle
        elseif strcomp(@tempValue, string("strand"))
          if byte[_Arguments + PortStyleOffset][portValue] <> Strand_Style
            byte[_Arguments + PortStyleOffset][portValue] := Strand_Style
            result |= Int_selectStyle
    
      code_pixelCount:
        portValue := Str.decimalToInteger(@tempName+10) - 1
        if byte[_Arguments + PortPixelCountOffset][portValue] <> (0 #> Str.decimalToInteger(@tempValue) <# MaxPixelCount) 
          byte[_Arguments + PortPixelCountOffset][portValue] := (0 #> Str.decimalToInteger(@tempValue) <# MaxPixelCount)
          result |= Int_pixelCount

      code_IP:
        portValue := Str.decimalToInteger(@tempName+2)           'Get portnumber from name and convert to IP segment number.
        if byte[_Arguments + IPAddressOffset][portValue] <> (0 #> Str.decimalToInteger(@tempValue) <# 255)
          byte[_Arguments + IPAddressOffset][portValue] := (0 #> Str.decimalToInteger(@tempValue) <# 255)
          result |= Int_IP
     
      code_Subnet:
        portValue := Str.decimalToInteger(@tempName+6)
        if byte[_Arguments + SubnetMaskOffset][portValue] <> (0 #> Str.decimalToInteger(@tempValue) <# 255)
          byte[_Arguments + SubnetMaskOffset][portValue] := (0 #> Str.decimalToInteger(@tempValue) <# 255)
          result |= Int_Subnet
   
      code_Gateway:
        portValue := Str.decimalToInteger(@tempName+7)
        if byte[_Arguments + GatewayAddressOffset][portValue] <> (0 #> Str.decimalToInteger(@tempValue) <# 255)
          byte[_Arguments + GatewayAddressOffset][portValue] := (0 #> Str.decimalToInteger(@tempValue) <# 255)
          result |= Int_Gateway
       
      OTHER:
        
    if done
      quit
      
  return
    
PUB GetNameCode(_tempName)

  CASE hash(_tempName)
    hash_NetMode:
      return code_NetMode
    hash_selectInput:
      return code_selectInput
    hash_button:
      return code_button

  if InStr(0, _tempName, String("PortU")) == 0
    return code_portU

  if InStr(0, _tempName, String("PortS")) == 0   
    return code_portS

  if InStr(0, _tempName, String("selectStyle")) == 0
    return code_style

  if InStr(0, _tempName, String("PixelCount")) == 0
    return code_PixelCount
    
  if InStr(0, _tempName, String("IP")) == 0   
    return code_IP

  if InStr(0, _tempName, String("Subnet")) == 0
    return code_Subnet

  if InStr(0, _tempName, String("Gateway")) == 0
    return code_Gateway

PUB hash(str_addr) | ch

  result := FNV_OFFSET
  repeat while (ch := byte[str_addr++])
    result := (result * FNV_PRIME) ^ ch

PRI HTMLBufferControl(value) : result

'Command = Clear
  CASE value
    CLEAR:
      bytefill(_HTMLBuffer, 0, HTMLBufferSize)
    GET_LENGTH:
      result := strSize(_HTMLBuffer)
    UPDATE_HEADER_LENGTH:
      'bytemove(@HTMLBuffer+(@httpHeaderLength-@httpHeader), Num.decf(strsize(@HTMLBuffer)-strsize(@httpHeader), 4), 4)  'finally, update header length.    
      'bytemove(_HTMLBuffer+D2E.getBlockSize(httpHeader)-1 -8,  Num.decf(strsize(_HTMLBuffer)-D2E.getBlockSize(httpHeader)+1, 4), 4)

  return

PRI HTMLBufferConcatFromRam(_StringPtr) : error

  error := false
  
  if strsize(_StringPtr) => (HTMLBufferSize - strSize(_HTMLBuffer))
    error := true
  else
    bytemove(_HTMLBuffer+strSize(_HTMLBuffer), _StringPtr, strsize(_StringPtr))

  return

PRI HTMLBufferConcatFromEEPROM(address) : error

  error := false
  
  if D2E.getBlockSize(address) => (HTMLBufferSize - strSize(_HTMLBuffer))
    error := true
  else
    D2E.readBlock(address, _HTMLBuffer + strSize(_HTMLBuffer))

  return
  
PRI InStr(StartPos,String1Address,String2Address)|size1,size2,i
    {
      String Search: Compares two strings, if one string is located within the other
      string, the value returned is the starting position within the LONGEST string
      that the SHORTER string can be found.  If there is no match, the result is a
      -1. You may also specify a starting position within the longest string to begin
      a search.
       
    } 
      
      size1 := strsize(String1Address)
      size2 := strsize(String2Address)
      if size1<>0 and size2<>0            '<- Zero length string not allowed
         if size1 > size2
            repeat i from StartPos to size1-size2
              bytemove(@Stringbuffer,String1Address+i,size2)
              byte[@Stringbuffer][size2] := 0
              if strcomp(@Stringbuffer,String2Address)
                 return i 
         else
            repeat i from StartPos to size2-size1
              bytemove(@Stringbuffer,String2Address+i,size1)
              byte[@Stringbuffer][size1] := 0
              if strcomp(@Stringbuffer,String1Address)
                 return i               
      result := -1
      